from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import Face
import math
import rocolib.utils.numsym as np


class Trapezoid(FoldedComponent):

    def define(self):
        self.addParameter("width", 50, paramType="length")
        self.addParameter("depth", 20, paramType="length")
        self.addParameter("bangle", 45, paramType="angle", minValue=1)
        self.addParameter("side", 10, paramType="length")

        #float(self.getParameter("depth") * np.sqrt(2.))
        self.addEdgeInterface("topedge", "e2", "width")
        self.addEdgeInterface("ledge", "e1", "side")
        self.addEdgeInterface("redge", "e3", "side")
        self.addEdgeInterface("botedge", "e0", "width")
        self.addFaceInterface("face0", "f")

    def assemble(self):
        d = self.getParameter("depth")
        w = self.getParameter("width")
        x = d / np.tan(np.deg2rad(self.getParameter("bangle")))

        # rs = []
        # rs.append(Face("f", ((0, 0), (x, -d), (x + w, -d), (x + x + w, 0))))
        self.addFace(Face("f", ((0, 0), (x, -d), (x + w, -d), (x + x + w, 0))))
        # self.attachEdge(None, rs[0], "e0", prefix="r0", angle=90)


if __name__ == "__main__":
    Trapezoid.test()

