from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import RegularNGon2 as Shape
from rocolib.utils.transforms import Translate


class TwoNGons(FoldedComponent):
  def define(self):
    self.addParameter("n1", 5, valueType="int", minValue=3)
    self.addParameter("n2", 3, valueType="int", minValue=3)
    self.addParameter("d", 10, paramType="length")
    self.addParameter("radius", 25, paramType="length")

  def assemble(self):
    n1 = self.getParameter("n1")
    n2 = self.getParameter("n2")
    d = self.getParameter("d")
    l = self.getParameter("radius")

    self.addFace(Shape("", n1, l), "r1")
    self.attachFace("r1", Shape("", n2, l), "r2", Translate([0,0,d]))

if __name__ == "__main__":
    TwoNGons.test()
